# Program to generate a random sequence of DNA. User inputs the names of the input and output files.
# The programs reads the input sequence and change it to a random sequence with the same length.
# Random DNA sequence will be written in the output file in the FASTA format.
# This program shows the percentage for each base read and generated in the final DNA sequence.
import random
# Reads input file name
fastaIn = input("\nGive the input DNA file name => ")
fh = open(fastaIn,'r')  # Opens input file
seqIn = fh.readlines()  # Reads all of the lines in a file and returns them as elements in a list
fh.close()              # Closes input file
# Removes the item at the given position in the list, and return it.
seqIn.pop(0)    # Removes first element of the list (get rid of the first line)
# Transforms list in string
seq=''.join(seqIn)

# Removes all "/n" from the string seq
seq = seq.replace("\n","")

# Length of string is the number of amino acids (countAA)
seq_length = len(seq) 

# Set initial values for count_C_in, count_G_in, count_A_in, and count_T_in
count_C_in = 0
count_G_in = 0
count_A_in = 0
count_T_in = 0
# Looping through input sequence to count bases
for base_in in seq:
    if base_in == "C":                # For C
        count_C_in += 1               # Adds 1 to count_C_in
    elif base_in == "G":              # For G
        count_G_in += 1               # Adds 1 to count_G_in
    elif base_in == "A":              # For A
        count_A_in += 1               # Adds 1 to count_A_in
    else:                             # For T
        count_T_in += 1               # Adds 1 to count_T_in
# Reads output file name
fastaOut = input("\nGive the DNA file name => ")
# Test if output file has the same name as input file
while fastaOut == fastaIn:
    print("\nYou are trying to write in your input file, give another name for the output file!")
    fastaOut = input("\nGive the DNA file name => ")

# Opens DNA file
dna_out = open(fastaOut,"w")

# Set initial values for count_bases, count_C, count_G, count_A, count_T, and dna
count_bases = 0
count_C = 0
count_G = 0
count_A = 0
count_T = 0
dna = ""

# while loop to generate random sequence
while count_bases < seq_length:
    base_number = random.randint(1,4)   # Generates random number in [1,4]
    if base_number == 1:                # For C
        base = "C"
        count_C += 1                    # Adds 1 to count_C
    elif base_number == 2:              # For G
        base = "G"
        count_G += 1                    # Adds 1 to count_G
    elif base_number == 3:              # For A
        base = "A"
        count_A += 1                    # Adds 1 to count_A
    else:                               # For T
        base = "T"                      
        count_T += 1                    # Adds 1 to count_T
    dna = "".join([dna,base])           # Adds to dna sequence using .join to add strings
    # dna = dna+base                    # We may use operator "+" to add string
    count_bases += 1                    # Adds to count_bases

# Calculates percentage for each base
if count_bases > 0:
    # For random sequence
    perc_C = 100*count_C/count_bases
    perc_G = 100*count_G/count_bases
    perc_A = 100*count_A/count_bases
    perc_T = 100*count_T/count_bases
    # For input sequence
    perc_C_in = 100*count_C_in/count_bases
    perc_G_in = 100*count_G_in/count_bases
    perc_A_in = 100*count_A_in/count_bases
    perc_T_in = 100*count_T_in/count_bases
    
# Shows input and random dna sequences
print("\nMy input DNA sequence:")
print(seq)
print("\nMy random DNA sequence:")
print(dna)

# Writes first line in the output file
dna_out.write(">Random DNA \n")

# Writes sequence to output file
line = ""       # Assigns "" to variable line
# Loop for to write bases to output file
for my_base in dna: 
    line = "".join([line,my_base])  # Adds my_base to string line
    if len(line) == 80:             # Tests whether the number of bases in the string line is 80
        line = line+"\n"            # Adds "\n" to end of the string
        dna_out.write(line)         # Writes the string line to the output file
        line = ""                   # Sets line to empty
# Writes sequence for len(line) < 80
if len(line) < 80:
    dna_out.write(line)
# Closes DNA file
dna_out.close()
# Shows percentage for each base in the random sequence
print("\nBase\t\tInput DNA(%)\tRandom DNA(%)")
print("C \t\t",perc_C_in,"\t\t",perc_C)
print("G \t\t",perc_G_in,"\t\t",perc_G)
print("A \t\t",perc_A_in,"\t\t",perc_A)
print("T \t\t",perc_T_in,"\t\t",perc_T)